--This file computes Betti tables for P^1 for d = 7 and b = 1
A := degreesRing 2
new HashTable from {
--tb stands for Total Betti numbers
"tb"=>new HashTable from {(6,1) => 5, (0,0) => 2, (1,0) => 7, (0,1) => 0, (1,1) => 0, (2,0) => 0, (2,1) => 35, (3,0) => 0, (3,1) => 70, (4,0) => 0, (4,1) => 63, (5,0) => 0, (5,1) => 28, (6,0) => 0},
--mb stands for Multigraded Betti numbers
"mb"=>new HashTable from {(6,1) => A_0^27*A_1^23+A_0^26*A_1^24+A_0^25*A_1^25+A_0^24*A_1^26+A_0^23*A_1^27, (0,0) => A_0+A_1, (0,1) => 0, (1,0) => A_0^7*A_1+A_0^6*A_1^2+A_0^5*A_1^3+A_0^4*A_1^4+A_0^3*A_1^5+A_0^2*A_1^6+A_0*A_1^7, (2,0) => 0, (1,1) => 0, (2,1) => A_0^17*A_1^5+A_0^16*A_1^6+2*A_0^15*A_1^7+3*A_0^14*A_1^8+4*A_0^13*A_1^9+4*A_0^12*A_1^10+5*A_0^11*A_1^11+4*A_0^10*A_1^12+4*A_0^9*A_1^13+3*A_0^8*A_1^14+2*A_0^7*A_1^15+A_0^6*A_1^16+A_0^5*A_1^17, (3,0) => 0, (3,1) => A_0^21*A_1^8+2*A_0^20*A_1^9+3*A_0^19*A_1^10+5*A_0^18*A_1^11+7*A_0^17*A_1^12+8*A_0^16*A_1^13+9*A_0^15*A_1^14+9*A_0^14*A_1^15+8*A_0^13*A_1^16+7*A_0^12*A_1^17+5*A_0^11*A_1^18+3*A_0^10*A_1^19+2*A_0^9*A_1^20+A_0^8*A_1^21, (4,0) => 0, (4,1) => A_0^24*A_1^12+2*A_0^23*A_1^13+4*A_0^22*A_1^14+5*A_0^21*A_1^15+7*A_0^20*A_1^16+8*A_0^19*A_1^17+9*A_0^18*A_1^18+8*A_0^17*A_1^19+7*A_0^16*A_1^20+5*A_0^15*A_1^21+4*A_0^14*A_1^22+2*A_0^13*A_1^23+A_0^12*A_1^24, (5,0) => 0, (6,0) => 0, (5,1) => A_0^26*A_1^17+2*A_0^25*A_1^18+3*A_0^24*A_1^19+4*A_0^23*A_1^20+4*A_0^22*A_1^21+4*A_0^21*A_1^22+4*A_0^20*A_1^23+3*A_0^19*A_1^24+2*A_0^18*A_1^25+A_0^17*A_1^26},
--sb represents the betti numbers as sums of Schur functors
"sb"=>new HashTable from {(6,1) => {({27,23},1)}, (0,0) => {({1,0},1)}, (1,0) => {({7,1},1)}, (0,1) => {}, (1,1) => {}, (2,0) => {}, (2,1) => {({17,5},1)}, (3,0) => {}, (3,1) => {({21,8},1)}, (4,0) => {}, (4,1) => {({24,12},1)}, (5,0) => {}, (5,1) => {({26,17},1)}, (6,0) => {}},
--dw encodes the dominant weights in each entry
"dw"=>new HashTable from {(6,1) => {{27,23}}, (0,0) => {{1,0}}, (1,0) => {{7,1}}, (0,1) => {}, (1,1) => {}, (2,0) => {}, (2,1) => {{17,5}}, (3,0) => {}, (3,1) => {{21,8}}, (4,0) => {}, (4,1) => {{24,12}}, (5,0) => {}, (5,1) => {{26,17}}, (6,0) => {}},
--lw encodes the lex leading weight in each entry
"lw"=>new HashTable from {(6,1) => {27,23}, (0,0) => {1,0}, (1,0) => {7,1}, (0,1) => {}, (1,1) => {}, (2,0) => {}, (2,1) => {17,5}, (3,0) => {}, (3,1) => {21,8}, (4,0) => {}, (4,1) => {24,12}, (5,0) => {}, (5,1) => {26,17}, (6,0) => {}},
--nr encodes the number of distinct representations in each entry
"nr"=>new HashTable from {(6,1) => 1, (0,0) => 1, (1,0) => 1, (0,1) => 0, (1,1) => 0, (2,0) => 0, (2,1) => 1, (3,0) => 0, (3,1) => 1, (4,0) => 0, (4,1) => 1, (5,0) => 0, (5,1) => 1, (6,0) => 0},
--nrm encodes the number of representations with multiplicity in each entry
"nrm"=>new HashTable from {(6,1) => 1, (0,0) => 1, (1,0) => 1, (0,1) => 0, (1,1) => 0, (2,0) => 0, (2,1) => 1, (3,0) => 0, (3,1) => 1, (4,0) => 0, (4,1) => 1, (5,0) => 0, (5,1) => 1, (6,0) => 0},
--er encodes the errors in the computed multigraded Hilbert series via our Schur method in each entry
"er"=>new HashTable from {(6,1) => 5, (0,0) => 2, (1,0) => 7, (0,1) => 0, (1,1) => 0, (2,0) => 0, (2,1) => 35, (3,0) => 0, (3,1) => 70, (4,0) => 0, (4,1) => 63, (5,0) => 0, (5,1) => 28, (6,0) => 0},
--bs encodes the Boij-Soederberg coefficients each entry
"bs"=>{5040/1},
}
